diff --git a/dev-ruby/pg/Manifest b/dev-ruby/pg/Manifest
deleted file mode 100644
index c11d5bca8..000000000
--- a/dev-ruby/pg/Manifest
+++ /dev/null
@@ -1 +0,0 @@
-DIST pg-0.20.0.gem 230400 SHA256 855f7a0f8b28bb2ef71c1b3b05612be551452dbdc27519908e5d39a3257fac0f SHA512 8c7ef2e3b0cb43f42b4f96c5995cd9ff8b01a0d0fc1cfd24d1053e27fa6d16f4eb7008fcb5f86445ad000429898df0215f7ee89b4da9500ddc4df04f5f2a10e2 WHIRLPOOL bdf51372e9a4282a39eb8c2c68ecb1545f54c2c8bfc96f86fc02ccac75d72566372e79eae8c9cdcd3af084c6fda7d23cda458e5baa3602e9ffff6c7eebe8b5a9
diff --git a/dev-ruby/pg/metadata.xml b/dev-ruby/pg/metadata.xml
deleted file mode 100644
index d5e99f216..000000000
--- a/dev-ruby/pg/metadata.xml
+++ /dev/null
@@ -1,11 +0,0 @@
-
-
-
-
- ruby@gentoo.org
- Gentoo Ruby Project
-
-
- ged/ruby-pg
-
-
diff --git a/dev-ruby/pg/pg-0.20.0.ebuild b/dev-ruby/pg/pg-0.20.0.ebuild
deleted file mode 100644
index 4e1f7fd31..000000000
--- a/dev-ruby/pg/pg-0.20.0.ebuild
+++ /dev/null
@@ -1,62 +0,0 @@
-# Copyright 1999-2016 Gentoo Foundation
-# Distributed under the terms of the GNU General Public License v2
-
-EAPI=5
-# ruby19 test fail
-USE_RUBY="ruby21 ruby22 ruby23 ruby24"
-
-RUBY_FAKEGEM_RECIPE_TEST="rspec3"
-
-RUBY_FAKEGEM_TASK_DOC="docs"
-RUBY_FAKEGEM_DOCDIR="doc"
-RUBY_FAKEGEM_EXTRADOC="ChangeLog Contributors.rdoc README.rdoc History.rdoc"
-
-inherit multilib ruby-fakegem
-
-DESCRIPTION="Ruby extension library providing an API to PostgreSQL"
-HOMEPAGE="https://bitbucket.org/ged/ruby-pg/"
-
-LICENSE="|| ( GPL-2 Ruby )"
-SLOT="0"
-KEYWORDS="~alpha ~amd64 ~arm ~hppa ~ppc ~ppc64 ~x86 ~x86-fbsd ~amd64-linux ~x86-linux ~ppc-macos ~x64-macos ~x86-macos ~sparc-solaris ~sparc64-solaris ~x64-solaris ~x86-solaris"
-IUSE=""
-
-RDEPEND+=" dev-db/postgresql:*"
-DEPEND+=" dev-db/postgresql
- test? ( >=dev-db/postgresql-9.4[server,threads] )"
-
-ruby_add_bdepend "
- doc? (
- dev-ruby/hoe
- || ( >=dev-ruby/yard-0.6.1 dev-ruby/rdoc ) )"
-
-all_ruby_prepare() {
- # hack the Rakefile to make it sure that it doesn't load
- # rake-compiler (so that we don't have to depend on it and it
- # actually works when building with USE=doc).
- sed -i \
- -e '/Rakefile.cross/s:^:#:' \
- -e '/ExtensionTask/,/^end$/ s:^:#:' \
- Rakefile || die
-}
-
-each_ruby_configure() {
- ${RUBY} -C ext extconf.rb || die "extconf.rb failed"
-}
-
-each_ruby_compile() {
- emake V=1 -C ext CFLAGS="${CFLAGS} -fPIC" archflag="${LDFLAGS}"
- cp ext/*$(get_libname) lib || die
-}
-
-each_ruby_test() {
- if [[ "${EUID}" -ne "0" ]]; then
- # Make the rspec call explicit, this way we don't have to depend
- # on rake-compiler (nor rubygems) _and_ we don't have to rebuild
- # the whole extension from scratch.
- RSPEC_VERSION=3 ruby-ng_rspec
- else
- ewarn "The userpriv feature must be enabled to run tests."
- eerror "Testsuite will not be run."
- fi
-}
diff --git a/net-analyzer/metasploit/metasploit-4.16.63-r1.ebuild b/net-analyzer/metasploit/metasploit-4.16.63-r1.ebuild
new file mode 100644
index 000000000..2e74ce040
--- /dev/null
+++ b/net-analyzer/metasploit/metasploit-4.16.63-r1.ebuild
@@ -0,0 +1,348 @@
+# Copyright 1999-2018 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI="6"
+
+#never ever ever have more than one ruby in here
+USE_RUBY="ruby23"
+inherit eutils ruby-ng
+
+if [[ ${PV} == "9999" ]] ; then
+ EGIT_REPO_URI="https://github.com/rapid7/metasploit-framework.git"
+ EGIT_CHECKOUT_DIR="${WORKDIR}"/all
+ inherit git-r3
+# KEYWORDS=""
+ SLOT="9999"
+else
+ ##Tags https://github.com/rapid7/metasploit-framework/releases
+ MY_PV=${PV/_p/-}
+ SRC_URI="https://github.com/rapid7/metasploit-framework/archive/${MY_PV}.tar.gz -> ${P}.tar.gz"
+ KEYWORDS="~amd64 ~x86"
+ RUBY_S="${PN}-framework-${MY_PV}"
+ inherit versionator
+ SLOT="$(get_version_component_range 1).$(get_version_component_range 2)"
+fi
+
+DESCRIPTION="Advanced framework for developing, testing, and using vulnerability exploit code"
+HOMEPAGE="http://www.metasploit.org/"
+LICENSE="BSD"
+IUSE="development +java nexpose openvas oracle +pcap test"
+
+#multiple known bugs with tests reported upstream and ignored
+#http://dev.metasploit.com/redmine/issues/8418 - worked around (fix user creation when possible)
+RESTRICT="test"
+
+#grep spec.add_runtime_dependency metasploit-framework.gemspec | sort
+#dev-ruby/nexpose is required
+
+RUBY_COMMON_DEPEND="virtual/ruby-ssl
+ dev-ruby/nexpose
+ >=dev-ruby/actionpack-4.2.6:4.2
+ >=dev-ruby/activerecord-4.2.6:4.2
+ >=dev-ruby/activesupport-4.2.6:4.2
+ dev-ruby/backports
+ dev-ruby/bcrypt-ruby
+ dev-ruby/bcrypt_pbkdf
+ dev-ruby/bit-struct
+ dev-ruby/bundler
+ dev-ruby/dnsruby
+ dev-ruby/faker
+ dev-ruby/filesize
+ dev-ruby/jsobfu:*
+ dev-ruby/json:*
+ dev-ruby/metasm:*
+ dev-ruby/metasploit-concern
+ =dev-ruby/rake-10.0.0
+ >=dev-ruby/factory_girl-4.1.0 )"
+ #lorcon doesn't support ruby21
+ #lorcon? ( net-wireless/lorcon[ruby] )
+ruby_add_bdepend "${RUBY_COMMON_DEPEND}
+ test? ( >=dev-ruby/factory_girl-4.1.0
+ dev-ruby/fivemat
+ dev-ruby/database_cleaner
+ >=dev-ruby/rspec-2.12
+ dev-ruby/shoulda-matchers
+ dev-ruby/timecop
+ >=dev-ruby/rake-10.0.0 )"
+ruby_add_rdepend "${RUBY_COMMON_DEPEND}"
+
+COMMON_DEPEND="dev-db/postgresql[server]
+ >=app-crypt/johntheripper-1.7.9-r1[-minimal]
+ net-analyzer/nmap"
+RDEPEND+=" ${COMMON_DEPEND}
+ >=app-eselect/eselect-metasploit-0.16"
+
+RESTRICT="strip"
+
+QA_PREBUILT="
+ usr/lib*/${PN}${SLOT}/data/templates/template_x86_linux.bin
+ usr/lib*/${PN}${SLOT}/data/templates/template_armle_linux.bin
+ usr/lib*/${PN}${SLOT}/data/templates/template_x86_solaris.bin
+ usr/lib*/${PN}${SLOT}/data/templates/template_x64_linux.bin
+ usr/lib*/${PN}${SLOT}/data/templates/template_x64_linux_dll.bin
+ usr/lib*/${PN}${SLOT}/data/templates/template_x86_bsd.bin
+ usr/lib*/${PN}${SLOT}/data/templates/template_x64_bsd.bin
+ usr/lib*/${PN}${SLOT}/data/templates/template_mipsbe_linux.bin
+ usr/lib*/${PN}${SLOT}/data/templates/template_mipsle_linux.bin
+ usr/lib*/${PN}${SLOT}/data/meterpreter/msflinker_linux_x86.bin
+ usr/lib*/${PN}${SLOT}/data/meterpreter/ext_server_sniffer.lso
+ usr/lib*/${PN}${SLOT}/data/meterpreter/ext_server_networkpug.lso
+ usr/lib*/${PN}${SLOT}/data/meterpreter/ext_server_stdapi.lso
+ usr/lib*/${PN}${SLOT}/data/exploits/CVE-2013-2171.bin
+ usr/lib*/${PN}${SLOT}/data/exploits/CVE-2014-3153.elf
+ usr/lib*/${PN}${SLOT}/data/exploits/mysql/lib_mysqludf_sys_32.so
+ usr/lib*/${PN}${SLOT}/data/android/libs/x86/libndkstager.so
+ usr/lib*/${PN}${SLOT}/data/android/libs/mips/libndkstager.so
+ usr/lib*/${PN}${SLOT}/data/android/libs/armeabi/libndkstager.so
+ usr/lib*/${PN}${SLOT}/data/templates/template_x86_linux_dll.bin
+ usr/lib*/${PN}${SLOT}/data/templates/template_armle_linux_dll.bin
+ usr/lib*/${PN}${SLOT}/data/templates/template_aarch64_linux.bin
+ "
+
+pkg_setup() {
+ if use test; then
+ su postgres -c "dropdb msf_test_database" #this is intentionally allowed to fail
+ su postgres -c "createuser msf_test_user -d -S -R"
+ if [ $? -ne 0 ]; then
+ su postgres -c "dropuser msf_test_user" || die
+ su postgres -c "createuser msf_test_user -d -S -R" || die
+ fi
+ su postgres -c "createdb --owner=msf_test_user msf_test_database" || die
+ fi
+ ruby-ng_pkg_setup
+}
+
+all_ruby_unpack() {
+ if [[ ${PV} == "9999" ]] ; then
+ git-r3_src_unpack
+ else
+ default_src_unpack
+# mv "${WORKDIR}"/all/msf3/* "${WORKDIR}"/all
+# rm -r msf3
+ #msf_version=$(grep --color=never "CURRENT_VERSION =" ${S}/spec/lib/msf/core/framework_spec.rb)
+ #msf_version=${msf_version#*=}
+ fi
+}
+
+all_ruby_prepare() {
+ # add psexec patch from pull request 2657 to allow custom exe templates from any files, bypassing most AVs
+ #epatch "${FILESDIR}/agix_psexec_pull-2657.patch"
+ eapply_user
+
+ #remove random "cpuinfo" binaries which a only needed to detect which bundled john to run
+ rm -r data/cpuinfo
+
+ #remove unneeded ruby bundler versioning files
+ #Gemfile.lock contains the versions tested by the msf team but not the hard requirements
+ #we regen this file in each_ruby_prepare
+ rm Gemfile.lock
+
+ #The Gemfile contains real known deps
+ sed -i "/gem 'fivemat'/s/, '1.2.1'//" Gemfile || die
+ #use released packetfu
+ sed -i "s/1.1.13.pre/1.1.13/" metasploit-framework.gemspec || die
+ #use the stable pg
+ #https://github.com/rapid7/metasploit-framework/issues/10234
+ sed -i "s/dependency 'pg', '0.20.0'/dependency 'pg', '0.21.0'/" metasploit-framework.gemspec || die
+ #git gems are only for ruby24 support and we are not there yet
+ sed -i "/git:/d" Gemfile || die
+
+ #now we edit the Gemfile based on use flags
+ if ! use pcap; then
+ sed -i -e "/^group :pcap do/,/^end$/d" Gemfile || die
+ fi
+ if ! use nexpose; then
+ sed -i -e "/nexpose/d" metasploit-framework.gemspec || die
+ fi
+ #no support for nessus right now
+ #if ! use nessus; then
+ sed -i -e "/nessus/d" metasploit-framework.gemspec || die
+ #fi
+ if ! use openvas; then
+ sed -i -e "/openvas-omp/d" metasploit-framework.gemspec || die
+ fi
+ #even if we pass --without=blah bundler still calculates the deps and messes us up
+ if ! use development; then
+ sed -i -e "/^group :development do/,/^end$/d" Gemfile || die
+ fi
+ if ! use test; then
+ sed -i -e "/^group :test/,/^end$/d" Gemfile || die
+ fi
+ if ! use test && ! use development; then
+ sed -i -e "/^group :development/,/^end$/d" Gemfile || die
+ fi
+ #We don't need simplecov
+ sed -i -e "/^group :coverage/,/^end$/d" Gemfile || die
+ sed -i -e "s#require 'simplecov'##" spec/spec_helper.rb || die
+
+ #we need to edit the gemspec too, since it tries to call git instead of anything sane
+ #probably a better way to fix this... if I care at some point
+ sed -i -e "/^ spec.files/,/^ }/d" metasploit-framework.gemspec || die
+
+ #https://bugs.gentoo.org/show_bug.cgi?id=584522 no tzinfo-data by choice in gentoo
+ sed -i '/tzinfo-data/d' metasploit-framework.gemspec
+
+ #let's bogart msfupdate
+ rm msfupdate
+ echo "#!/bin/sh" > msfupdate
+ echo "echo \"[*]\"" >> msfupdate
+ echo "echo \"[*] Attempting to update the Metasploit Framework...\"" >> msfupdate
+ echo "echo \"[*]\"" >> msfupdate
+ echo "echo \"\"" >> msfupdate
+ if [[ ${PV} == "9999" ]] ; then
+ echo "if [ -x /usr/bin/smart-live-rebuild ]; then" >> msfupdate
+ echo " smart-live-rebuild -f net-analyzer/metasploit" >> msfupdate
+ echo "else" >> msfupdate
+ echo " echo \"Please install app-portage/smart-live-rebuild for a better experience.\"" >> msfupdate
+ echo "emerge --oneshot \"=${CATEGORY}/${PF}\"" >> msfupdate
+ echo "fi" >> msfupdate
+ else
+ echo "echo \"Unable to update tagged version of metasploit.\"" >> msfupdate
+ echo "echo \"If you want the latest please install and eselect the live version (metasploit9999)\"" >> msfupdate
+ echo "echo \"emerge metasploit:9999 -vat && eselect metasploit set metasploit9999\"" >> msfupdate
+ fi
+ #this is set executable in src_install
+
+ #install our database.yml file before tests are run
+ cp "${FILESDIR}"/database.yml config/
+
+}
+
+each_ruby_prepare() {
+ MSF_ROOT="." BUNDLE_GEMFILE=Gemfile ${RUBY} -S bundle install --local || die
+ MSF_ROOT="." BUNDLE_GEMFILE=Gemfile ${RUBY} -S bundle check || die
+
+ #force all metasploit executables to use desired ruby version
+ #https://dev.metasploit.com/redmine/issues/8357
+ for file in $(ls -1 msf*)
+ do
+ #poorly adapted from python.eclass
+ sed -e "1s:^#![[:space:]]*\([^[:space:]]*/usr/bin/env[[:space:]]\)\?[[:space:]]*\([^[:space:]]*/\)\?ruby\([[:digit:]]\+\(\.[[:digit:]]\+\)\?\)\?\(\$\|[[:space:]].*\):#!\1\2${RUBY}:" -i "${file}" || die "Conversion of shebang in '${file}' failed"
+ done
+}
+
+each_ruby_test() {
+ #review dev-python/pymongo for ways to make the test compatible with FEATURES=network-sandbox
+
+ #we bogart msfupdate so no point in trying to test it
+ rm spec/msfupdate_spec.rb || die
+ #we don't really want to be uploading to virustotal during the tests
+ rm spec/tools/virustotal_spec.rb || die
+
+ # https://dev.metasploit.com/redmine/issues/8425
+ BUNDLE_GEMFILE=Gemfile ${RUBY} -S bundle exec rake db:create || die
+ BUNDLE_GEMFILE=Gemfile ${RUBY} -S bundle exec rake db:migrate || die
+
+ MSF_DATABASE_CONFIG=config/database.yml BUNDLE_GEMFILE=Gemfile ${RUBY} -S bundle exec rake || die
+ su postgres -c "dropuser msf_test_user" || die "failed to cleanup msf_test-user"
+}
+
+each_ruby_install() {
+ #Tests have already been run, we don't need this stuff
+ rm -r spec || die
+ rm -r test || die
+ rm Gemfile.lock || die
+
+ #I'm 99% sure that this will only work for as long as we only support one ruby version. Creativity will be needed if we wish to support multiple.
+ # should be as simple as copying everything into the target...
+ dodir /usr/$(get_libdir)/${PN}${SLOT}
+ cp -R * "${ED}"/usr/$(get_libdir)/${PN}${SLOT} || die "Copy files failed"
+ rm -Rf "${ED}"/usr/$(get_libdir)/${PN}${SLOT}/documentation "${ED}"/usr/$(get_libdir)/${PN}${SLOT}/README.md
+ fowners -R root:0 /
+
+}
+
+all_ruby_install() {
+ # do not remove LICENSE, bug #238137
+ dodir /usr/share/doc/${PF}
+ cp -R {documentation,README.md} "${ED}"/usr/share/doc/${PF} || die
+ dosym usr/share/doc/${PF}/documentation /usr/$(get_libdir)/${PN}${SLOT}/documentation
+
+ fperms +x /usr/$(get_libdir)/${PN}${SLOT}/msfupdate
+
+ #tell revdep-rebuild to ignore binaries meant for the target
+ dodir /etc/revdep-rebuild
+ cat <<-EOF > "${ED}"/etc/revdep-rebuild/99-metasploit${SLOT}
+ #These dirs contain prebuilt binaries for running on the TARGET not the HOST
+ SEARCH_DIRS_MASK="/usr/lib*/${PN}${SLOT}/data/meterpreter"
+ SEARCH_DIRS_MASK="/usr/lib*/${PN}${SLOT}/data/exploits"
+ EOF
+}
+
+pkg_postinst() {
+ elog "Before use you should run 'env-update' and '. /etc/profile'"
+ elog "otherwise you may be missing important environmental variables."
+
+ elog "You need to prepare the database by running:"
+ elog "emerge --config postgresql"
+ elog "/etc/init.d/postgresql- start"
+ elog "emerge --config =metasploit-${PV}"
+
+ "${EROOT}"/usr/bin/eselect metasploit set --use-old ${PN}${SLOT}
+
+ einfo
+ elog "Adjust /usr/lib/${PN}${SLOT}/config/database.yml if necessary"
+}
+
+pkg_config() {
+ einfo "If the following fails, it is likely because you forgot to start/config postgresql first"
+ su postgres -c "createuser msf_user -D -S -R"
+ su postgres -c "createdb --owner=msf_user msf_database"
+}
diff --git a/net-wireless/urh/urh-2.1.0.ebuild b/net-wireless/urh/urh-2.1.0.ebuild
deleted file mode 100644
index 4c46411f8..000000000
--- a/net-wireless/urh/urh-2.1.0.ebuild
+++ /dev/null
@@ -1,39 +0,0 @@
-# Copyright 1999-2018 Gentoo Foundation
-# Distributed under the terms of the GNU General Public License v2
-
-EAPI=6
-
-PYTHON_COMPAT=( python{3_4,3_5} )
-inherit distutils-r1 eutils
-
-DESCRIPTION="Universal Radio Hacker: investigate wireless protocols like a boss"
-HOMEPAGE="https://github.com/jopohl/urh"
-SRC_URI="https://github.com/jopohl/${PN}/archive/v${PV}.tar.gz -> ${P}.tar.gz"
-
-LICENSE="Apache-2.0"
-SLOT="0"
-KEYWORDS="~amd64 ~x86"
-IUSE="hackrf rtlsdr uhd"
-
-DEPEND="${PYTHON_DEPS}
- net-wireless/gnuradio[zeromq]
- dev-python/numpy[${PYTHON_USEDEP}]
- dev-python/psutil[${PYTHON_USEDEP}]
- dev-python/pyzmq[${PYTHON_USEDEP}]
- dev-python/cython[${PYTHON_USEDEP}]
- hackrf? ( net-libs/libhackrf:= )
- rtlsdr? ( net-wireless/rtl-sdr:= )
- uhd? ( net-wireless/uhd:= )"
-RDEPEND="${DEPEND}
- dev-python/PyQt5[${PYTHON_USEDEP},testlib]
- net-wireless/gr-osmosdr"
-
-python_configure_all() {
- mydistutilsargs=(
- $(use_with hackrf)
- $(use_with rtlsdr)
- $(use_with uhd usrp)
- --without-airspy
- --without-limesdr
- )
-}
diff --git a/net-wireless/urh/urh-2.2.1.ebuild b/net-wireless/urh/urh-2.2.2.ebuild
similarity index 100%
rename from net-wireless/urh/urh-2.2.1.ebuild
rename to net-wireless/urh/urh-2.2.2.ebuild
diff --git a/profiles/pentoo/base/package.accept_keywords/dev-ruby b/profiles/pentoo/base/package.accept_keywords/dev-ruby
index 25fd83930..3908260f4 100644
--- a/profiles/pentoo/base/package.accept_keywords/dev-ruby
+++ b/profiles/pentoo/base/package.accept_keywords/dev-ruby
@@ -75,6 +75,7 @@ dev-ruby/i18n:0.7
~dev-ruby/http_configuration-1.0.4
#required by metasploit-9999
+~dev-ruby/nexpose-7.2.1
~dev-ruby/bcrypt_pbkdf-1.0.0 **
dev-ruby/rbnacl:4
dev-ruby/rbnacl-libsodium
@@ -200,7 +201,7 @@ dev-ruby/tzinfo-data
~dev-ruby/yard-0.8.7.6
dev-ruby/pdf-reader:2
~dev-ruby/ruby-rc4-0.1.5
-~dev-ruby/ascii85-1.0.2
+~dev-ruby/ascii85-1.0.3
~dev-ruby/hashery-2.1.2
~dev-ruby/afm-0.2.2
~dev-ruby/dnsruby-1.60.2